Fs = 2*pi*10; %freq amost
T = 5;

t = [0:1/Fs:T];


A1 = 1; %Amplitudes
A2 = 1;
alpha1 = 2*10; %Desvio padrão das Gaussianas
alpha2 = 3*10;
t1 = 3; %centro da Gaussiana
t2 = 3.5;
w1 = 15*2*pi; %o primeiro valor eh a freq da senóide modulada
w2 = 3*2*pi;

s1 = A1*exp(-alpha1*((t-t1).^2)/2 + sqrt(-1)*(w1*(t-t1)));
s2 = A2*exp(-alpha2*((t-t2).^2)/2 + sqrt(-1)*(w2*(t-t2)));

%faixa
yt_m1 = max(abs(real(s1)));
yt_m2 = max(abs(real(s2)));
yt_m = max([yt_m1,yt_m2]);

pt1 = pd_from_s(s1);
pt2 = pd_from_s(s2);
ff1 = psd_from_s(s1);
ff2 = psd_from_s(s2);

%faixa
yf_m1 = max(ff1);
yf_m2 = max(ff2);
yf_m = max([yf_m1,yf_m2]);

yp_m1 = max(pt1);
yp_m2 = max(pt2);
yp_m = max([yp_m1,yp_m2]);

subplot(2,2,1);
plot(t,s1);
axis([0 T -yt_m yt_m]);
title('s_1(t)= A_1 e^{(-\alpha_1(t-t_1)^2)/2 + j2\pi f_1(t-t_1)}')
ylabel('Amplitude')
xlabel('Time (s)')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A1=',num2str(A1)),','),strcat(strcat(' t1=',num2str(t1)),',')),' f1=',num2str(w1/(2*pi))),strcat(', a1=',num2str(alpha1))));

subplot(2,2,3);
plot(t,pt1);
axis([0 max(t) 0 yp_m]);
xlabel('Time (s)')
title('Power Density of s_1(t)');
ylabel('|s_1(t)|^2')

ff1p = ff1(ceil(size(ff1,2)/2):size(ff1,2));
freq_ff = [0:Fs/(size(s1,2)):Fs/2];
subplot(2,2,2);
plot(ff1p,freq_ff);
axis([0 yf_m 0 Fs/2]);
ylabel('Frequency (Hz)')
title('Power Spectrum Density of s_1(t)');
xlabel('|S_1(\omega)|^2')

[center_t1,width_t1] = center_width_mass(t,pt1)
[center_f1,width_f1] = center_width_mass(freq_ff,ff1p)

pause
subplot(2,2,1);
A1=repmat(pt1,size(ff1p,2),1).*repmat(ff1p',1,size(pt1,2));
imshow(flipud(A1));
ylabel('Frequency (Hz)')
xlabel('Time (s)')
title('Product of the two densities');
subplot(2,2,4);
plot(t,s1);
axis([0 T -yt_m yt_m]);
title('s_1(t)= A_1 e^{(-\alpha_1(t-t_1)^2)/2 + j2\pi f_1(t-t_1)}')
ylabel('Amplitude')
xlabel('Time (s)')


pause
%s2
figure;
subplot(2,2,1);
plot(t,s2);
axis([0 T -yt_m yt_m]);
title('s_2(t)= A_2 e^{(-\alpha_2(t-t_2)^2)/2 + j2\pi f_2(t-t_2)}')
ylabel('Amplitude')
xlabel('Time (s)')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A2=',num2str(A2)),','),strcat(strcat(' t2=',num2str(t2)),',')),' f2=',num2str(w2/(2*pi))),strcat(', a2=',num2str(alpha2))));

subplot(2,2,3);
plot(t,pt2);
axis([0 max(t) 0 yp_m]);
xlabel('Time (s)')
title('Power Density of s_2(t)');
ylabel('|s_2(t)|^2')

ff2p = ff2(ceil(size(ff2,2)/2):size(ff2,2));
freq_ff = [0:Fs/(size(s2,2)):Fs/2];
subplot(2,2,2);
plot(ff2p,freq_ff);
axis([0 yf_m 0 Fs/2]);
ylabel('Frequency (Hz)')
title('Power Spectrum Density of s_2(t)');
xlabel('|S_2(\omega)|^2')

[center_t2,width_t2] = center_width_mass(t,pt2)
[center_f2,width_f2] = center_width_mass(freq_ff,ff2p)

pause
subplot(2,2,1);
A2=repmat(pt2,size(ff2p,2),1).*repmat(ff2p',1,size(pt2,2));
imshow(flipud(A2));
ylabel('Frequency (Hz)')
xlabel('Time (s)')
title('Product of the two densities');
subplot(2,2,1);
plot(t,s2);
axis([0 T -yt_m yt_m]);
title('s_2(t)= A_2 e^{(-\alpha_2(t-t_2)^2)/2 + j2\pi f_2(t-t_2)}')
ylabel('Amplitude')
xlabel('Time (s)')



pause
%s
figure
s=s1+s2;

%faixa
yt_m = max(abs(real(s2)));

pt = pd_from_s(s);
ff = psd_from_s(s);

%faixa
yf_m = max(ff);

yp_m = max(pt);

subplot(2,2,1);
plot(t,s);
axis([0 T -yt_m yt_m]);
title('s=s_1(t)+s_2(t)');
ylabel('Amplitude')
xlabel('Time (s)')

subplot(2,2,3);
plot(t,pt);
axis([0 max(t) 0 yp_m]);
xlabel('Time (s)')
title('Power Density of s(t)');
ylabel('|s(t)|^2')

ffp = ff(ceil(size(ff,2)/2):size(ff,2));
freq_ff = [0:Fs/(size(s,2)):Fs/2];
subplot(2,2,2);
plot(ffp,freq_ff);
axis([0 yf_m 0 Fs/2]);
ylabel('Frequency (Hz)')
title('Power Spectrum Density of s(t)');
xlabel('|S(\omega)|^2')

[center_ts,width_ts] = center_width_mass(t,pt)
[center_fs,width_fs] = center_width_mass(freq_ff,ffp)

pause
subplot(2,2,1);
A=repmat(pt,size(ffp,2),1).*repmat(ffp',1,size(pt,2));
imshow(flipud(A));
ylabel('Frequency (Hz)')
xlabel('Time (s)')
title('Product of the two densities for s(t)');

subplot(2,2,4)
imshow(flipud(A1+A2));
ylabel('Frequency (Hz)')
xlabel('Time (s)')
title('Sum of the densities for s_1 and s_2');
