Fs = 2*pi*20; %freq amost
T = 5;

t = [0:1/Fs:T];
A1 = 1; %Amplitudes
alpha1 = 2*10; %Desvio padrão das Gaussianas
t1 = 3; %centro da Gaussiana
w1 = 8*2*pi; %o primeiro valor eh a freq da senóide modulada


s1 = A1*exp(-alpha1*((t-t1).^2)/2 + sqrt(-1)*w1*(t-t1));
yt_m = max(abs(real(s1)));
ff1 = psd_from_s(s1);
yf_m = max(ff1);

figure;
subplot(4,1,1);
plot(t,s1);
axis([0 T -yt_m yt_m]);
title('s_1(t)= A_1 e^{(-\alpha_1(t-t_1)^2)/2 + j2\pi f_1(t-t_1)}')
ylabel('Amplitude')
xlabel('Time (s)')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A1=',num2str(A1)),','),strcat(strcat(' t1=',num2str(t1)),',')),' f1=',num2str(w1/(2*pi))),strcat(', a1=',num2str(alpha1))));
subplot(4,1,2);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff1);
axis([-Fs/2 Fs/2 0 yf_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of s_1(t)');
ylabel('|S_1(\omega)|^2')

[center_f1,width_f1] = center_width_mass([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff1)


s1 = A1*exp(-alpha1*((t-t1).^2)/2).*cos(w1*(t-t1));
yt_m = max(abs(real(s1)));
ff1 = psd_from_s(s1);
yf_m = max(ff1);

%xfigure;
subplot(4,1,3);
plot(t,s1);
axis([0 T -yt_m yt_m]);
title('s_1(t)= A_1 e^{(-\alpha_1(t-t_1)^2)/2} cos(2\pi f_1(t-t_1))')
ylabel('Amplitude')
xlabel('Time (s)')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A1=',num2str(A1)),','),strcat(strcat(' t1=',num2str(t1)),',')),' f1=',num2str(w1/(2*pi))),strcat(', a1=',num2str(alpha1))));
subplot(4,1,4);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff1);
axis([-Fs/2 Fs/2 0 yf_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of s_1(t)');
ylabel('|S_1(\omega)|^2')

[center_f1,width_f1] = center_width_mass([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff1)
