Fs = 2*pi*20; %freq amost
T = 5;

t = [0:1/Fs:T];
A1 = 1; %Amplitudes
alpha1 = 1*10; %Desvio padrão das Gaussianas
t1 = 12/6; %centro da Gaussiana
w1 = 6*2*pi; %o primeiro valor eh a freq da senóide modulada

s1 = A1*exp(-alpha1*((t-t1).^2)/2).*cos(w1*(t-t1));
yt_m = max(abs(real(s1)));
ff1 = psd_from_s(s1);
yf_m = max(ff1);

hs1 = hilbert(s1);
yth_m = max(abs(real(hs1)));
ffh1 = psd_from_s(imag(hs1));
yfh_m = max(ffh1);


figure;
subplot(2,2,1);
plot(t,s1);
axis([0 T -yt_m yt_m]);
title('s(t)= A_1 e^{(-\alpha_1(t-t_1)^2)/2} cos(2\pi f_1(t-t_1))')
ylabel('Amplitude')
xlabel('Time (s)')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A1=',num2str(A1)),','),strcat(strcat(' t1=',num2str(t1)),',')),' f1=',num2str(w1/(2*pi))),strcat(', a1=',num2str(alpha1))));
subplot(2,2,3);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff1);
axis([-Fs/2 Fs/2 0 yfh_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of s(t)');
ylabel('|S(\omega)|^2')

subplot(2,2,2);
plot(t,imag(hs1));
axis([0 T -yth_m yth_m]);
title('H(s(t))');
ylabel('Amplitude')
xlabel('Time (s)')

subplot(2,2,4);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ffh1);
axis([-Fs/2 Fs/2 0 yf_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of \^s(t) = H(s(t))');
ylabel('|\^S(\omega)|^2')

figure;
plot(t,s1);
ylabel('Amplitude')
xlabel('Time (s)')
hold on;
plot(t,imag(hs1), 'r');
legend('s(t)', 'H(s(t))');


figure
h1 = s1+sqrt(-1)*imag(hs1);
ffh1 = psd_from_s(h1);
yfh_m = max(ffh1);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ffh1);
axis([-Fs/2 Fs/2 0 yfh_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of z(t) = A(s(t))');
ylabel('|Z(\omega)|^2')
