s1 = A1*exp(-alpha1*((t-t1).^2)/2 + sqrt(-1)*w1*(t-t1));
s2 = A2*exp(-alpha2*((t-t2).^2)/2 + sqrt(-1)*w2*(t-t2));

%faixa
yt_m1 = max(abs(real(s1)));
yt_m2 = max(abs(real(s2)));
yt_m = max([yt_m1,yt_m2]);

ff1 = psd_from_s(s1);
ff2 = psd_from_s(s2);

%faixa
yf_m1 = max(ff1);
yf_m2 = max(ff2);
yf_m = max([yf_m1,yf_m2]);
 

figure;
subplot(4,1,1);
plot(t,s1);
axis([0 T -yt_m yt_m]);
title('s_1(t)= A_1 e^{(-\alpha_1(t-t_1)^2)/2 + j2\pi f_1(t-t_1)}')
ylabel('Amplitude')
xlabel('Time (s)')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A1=',num2str(A1)),','),strcat(strcat(' t1=',num2str(t1)),',')),' f1=',num2str(w1/(2*pi))),strcat(', a1=',num2str(alpha1))));
subplot(4,1,2);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff1);
axis([-Fs/2 Fs/2 0 yf_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of s_1(t)');
ylabel('|S_1(\omega)|^2')

subplot(4,1,3);
plot(t,s2);
axis([0 T -yt_m yt_m]);
title('s_2(t)= A_2 e^{(-\alpha_2(t-t_2)^2)/2 + j2\pi f_2(t-t_2)}')
text(1,yt_m/2,strcat(strcat(strcat(strcat(strcat('A2=',num2str(A2)),','),strcat(strcat(' t2=',num2str(t2)),',')),' f2=',num2str(w2/(2*pi))),strcat(', a2=',num2str(alpha2))));
ylabel('Amplitude')
xlabel('Time (s)')
subplot(4,1,4);
plot([-Fs/2:Fs/(size(s1,2)-1):Fs/2],ff2);
axis([-Fs/2 Fs/2 0 yf_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of s_2(t)');
ylabel('|S_2(\omega)|^2')

figure;

s=s1+s2;
yt_m = max(abs(real(s)));
ff = psd_from_s(s);
yf_m = max(ff);

subplot(2,1,1);
plot(t,s);
axis([0 T -yt_m yt_m]);
xlabel('Time (s)')
title('s(t)= s_1(t)+s_2(t)');
ylabel('Amplitude')

subplot(2,1,2);
plot([-Fs/2:Fs/(size(s,2)-1):Fs/2],ff);
axis([-Fs/2 Fs/2 0 yf_m]);
xlabel('Frequency (Hz)')
title('Power Spectrum Density of s(t)');
ylabel('|S(\omega)|^2')


